#include <stdlib.h>
#include <string.h>
#include "readnums.h"

/* Based on the HW21 solution, shows OMP parallelism on loops */

#define NODE_TO_POS(node) ((node)-1)

typedef struct depth_todo {
  int node;
  int depth;
} depth_todo;

int max_depth(int **numss, int node, int n)
{
  depth_todo *queue;
  int *seen;
  int qpos = 0, qcount = 0, max_depth = 0, depth;
  int j, child;
  
  queue = (depth_todo*)malloc(n * sizeof(depth_todo));

  seen = (int*)malloc(n * sizeof(int));
  memset(seen, 0, sizeof(int) * n);

  queue[qpos].node = node;
  queue[qpos].depth = 0;
  qcount++;
  seen[NODE_TO_POS(node)] = 1;

  while (qcount > 0) {
    node = queue[qpos].node;
    depth = queue[qpos].depth;
    --qcount;
    qpos = (qpos + 1) % n;

    if (max_depth < depth)
      max_depth = depth;

    for (j = 1; numss[NODE_TO_POS(node)][j]; j++) {
      child = numss[NODE_TO_POS(node)][j];
      if (!seen[NODE_TO_POS(child)]) {
        seen[NODE_TO_POS(child)] = 1;
        queue[(qpos + qcount) % n].node = child;
        queue[(qpos + qcount) % n].depth = depth + 1;
        qcount++;
      }
    }
  }

  free(queue);
  free(seen);

  return max_depth;
}

int main()
{
  int **numss;
  int n;

  numss = get_number_lines(stdin);

  for (n = 0; numss[n]; n++) { }

  printf("%d\n", max_depth(numss, 1, n));

  {
    int i, md, *d;
    d = (int *)malloc(sizeof(int) * n);

# pragma omp parallel
    for (i = 0; i < n; i++) {
      d[i] = max_depth(numss, i+1, n);
    }

    md = 0;
    for (i = 0; i < n; i++)
      if (md < d[i]) md = d[i];
    printf("%d\n", md);
  }

  return 0;
}
