#lang racket

(define-syntax parallel-begin
  (syntax-rules ()
    [(_ a b)
     (let ([f1 (future (lambda () a))]
           [f2 (future (lambda () b))])
       (touch f1)
       (touch f2))]))

; quicksort! : vector-of-num num num -> void
; effect: sorts vec between n (incl) and m (excl)
(define (quicksort! vec n m)
  (when (> (- m n) 1)
    (define pivot (vector-ref vec n))
    (define pre
      (for/fold ([pre n]) ([i (in-range (add1 n) m)])
        (define v (vector-ref vec i))
        (cond
          [(< v pivot)
           (vector-set! vec pre v)
           (vector-set! vec i (vector-ref vec (add1 pre)))
           (values (add1 pre))]
          [else (values pre)])))
    (vector-set! vec pre pivot)
    (if (> (- m n) (quotient (vector-length vec) 100))
        (parallel-begin 
         (quicksort! vec n pre)
         (quicksort! vec (add1 pre) m))
        (begin 
         (quicksort! vec n pre)
         (quicksort! vec (add1 pre) m)))))

(define v (for/vector ([n (in-lines)])
            (string->number n)))

(time (quicksort! v 0 (vector-length v)))


